import { Signer } from '@metaplex-foundation/umi';
import { ThirdPartySigner, ThirdPartySignerArgs } from '../generated';
import { GuardManifest } from '../guards';
/**
 * The thirdPartySigner guard requires a predefined
 * address to sign the mint transaction. The signer will need
 * to be passed within the mint settings of this guard.
 *
 * This allows for more centralized mints where every single
 * mint transaction has to go through a specific signer.
 */
export declare const thirdPartySignerGuardManifest: GuardManifest<ThirdPartySignerArgs, ThirdPartySigner, ThirdPartySignerMintArgs>;
export declare type ThirdPartySignerMintArgs = {
    signer: Signer;
};
