import { TokenBurn, TokenBurnArgs } from '../generated';
import { GuardManifest } from '../guards';
/**
 * The tokenBurn guard restricts minting to token holders
 * of a specified mint account and burns the holder's tokens
 * when minting. The `amount` determines how many tokens are required.
 *
 * This guard alone does not limit how many times a holder
 * can mint. A holder can mint as many times as they have
 * the required amount of tokens to burn.
 */
export declare const tokenBurnGuardManifest: GuardManifest<TokenBurnArgs, TokenBurn, TokenBurnMintArgs>;
export declare type TokenBurnMintArgs = Omit<TokenBurnArgs, 'amount'>;
