/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
import { Amount, Context, Option, OptionOrNullable, Pda, PublicKey, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
import { Serializer } from '@metaplex-foundation/umi/serializers';
import { ConfigLineSettings, ConfigLineSettingsArgs, Creator, CreatorArgs, HiddenSettings, HiddenSettingsArgs } from '../types';
export declare type InitializeCandyMachineInstructionAccounts = {
    /**
     * Candy Machine account. The account space must be allocated to allow accounts larger
     * than 10kb.
     *
     */
    candyMachine: PublicKey | Pda;
    /**
     * Authority PDA used to verify minted NFTs to the collection.
     *
     */
    authorityPda?: PublicKey | Pda;
    /**
     * Candy Machine authority. This is the address that controls the upate of the candy machine.
     *
     */
    authority?: PublicKey | Pda;
    /** Payer of the transaction. */
    payer?: Signer;
    /**
     * Metadata account of the collection.
     *
     */
    collectionMetadata?: PublicKey | Pda;
    /**
     * Mint account of the collection.
     *
     */
    collectionMint: PublicKey | Pda;
    /**
     * Master Edition account of the collection.
     *
     */
    collectionMasterEdition?: PublicKey | Pda;
    /**
     * Update authority of the collection. This needs to be a signer so the candy
     * machine can approve a delegate to verify minted NFTs to the collection.
     */
    collectionUpdateAuthority: Signer;
    /**
     * Collection authority record. The delegate is used to verify NFTs.
     *
     */
    collectionAuthorityRecord?: PublicKey | Pda;
    /**
     * Token Metadata program.
     *
     */
    tokenMetadataProgram?: PublicKey | Pda;
    /** System program. */
    systemProgram?: PublicKey | Pda;
};
export declare type InitializeCandyMachineInstructionData = {
    discriminator: Array<number>;
    /** Number of assets available */
    itemsAvailable: bigint;
    /** Symbol for the asset */
    symbol: string;
    /** Secondary sales royalty basis points (0-10000) */
    sellerFeeBasisPoints: Amount<'%', 2>;
    /** Max supply of each individual asset (default 0) */
    maxEditionSupply: bigint;
    /** Indicates if the asset is mutable or not (default yes) */
    isMutable: boolean;
    /** List of creators */
    creators: Array<Creator>;
    /** Config line settings */
    configLineSettings: Option<ConfigLineSettings>;
    /** Hidden setttings */
    hiddenSettings: Option<HiddenSettings>;
};
export declare type InitializeCandyMachineInstructionDataArgs = {
    /** Number of assets available */
    itemsAvailable: number | bigint;
    /** Symbol for the asset */
    symbol?: string;
    /** Secondary sales royalty basis points (0-10000) */
    sellerFeeBasisPoints: Amount<'%', 2>;
    /** Max supply of each individual asset (default 0) */
    maxEditionSupply?: number | bigint;
    /** Indicates if the asset is mutable or not (default yes) */
    isMutable?: boolean;
    /** List of creators */
    creators: Array<CreatorArgs>;
    /** Config line settings */
    configLineSettings?: OptionOrNullable<ConfigLineSettingsArgs>;
    /** Hidden setttings */
    hiddenSettings?: OptionOrNullable<HiddenSettingsArgs>;
};
/** @deprecated Use `getInitializeCandyMachineInstructionDataSerializer()` without any argument instead. */
export declare function getInitializeCandyMachineInstructionDataSerializer(_context: object): Serializer<InitializeCandyMachineInstructionDataArgs, InitializeCandyMachineInstructionData>;
export declare function getInitializeCandyMachineInstructionDataSerializer(): Serializer<InitializeCandyMachineInstructionDataArgs, InitializeCandyMachineInstructionData>;
export declare type InitializeCandyMachineInstructionArgs = InitializeCandyMachineInstructionDataArgs;
export declare function initializeCandyMachine(context: Pick<Context, 'programs' | 'eddsa' | 'identity' | 'payer'>, input: InitializeCandyMachineInstructionAccounts & InitializeCandyMachineInstructionArgs): TransactionBuilder;
