/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
import { TokenStandard, TokenStandardArgs } from '@metaplex-foundation/mpl-token-metadata';
import { Amount, Context, Option, OptionOrNullable, Pda, PublicKey, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
import { Serializer } from '@metaplex-foundation/umi/serializers';
import { ConfigLineSettings, ConfigLineSettingsArgs, Creator, CreatorArgs, HiddenSettings, HiddenSettingsArgs } from '../types';
export declare type InitializeCandyMachineV2InstructionAccounts = {
    /**
     * Candy Machine account. The account space must be allocated to allow accounts larger
     * than 10kb.
     *
     */
    candyMachine: PublicKey | Pda;
    /**
     * Authority PDA used to verify minted NFTs to the collection.
     *
     */
    authorityPda?: PublicKey | Pda;
    /**
     * Candy Machine authority. This is the address that controls the upate of the candy machine.
     *
     */
    authority?: PublicKey | Pda;
    /** Payer of the transaction. */
    payer?: Signer;
    /**
     * Authorization rule set to be used by minted NFTs.
     *
     */
    ruleSet?: PublicKey | Pda;
    /**
     * Metadata account of the collection.
     *
     */
    collectionMetadata?: PublicKey | Pda;
    /**
     * Mint account of the collection.
     *
     */
    collectionMint: PublicKey | Pda;
    /**
     * Master Edition account of the collection.
     *
     */
    collectionMasterEdition?: PublicKey | Pda;
    /**
     * Update authority of the collection. This needs to be a signer so the candy
     * machine can approve a delegate to verify minted NFTs to the collection.
     */
    collectionUpdateAuthority: Signer;
    /**
     * Metadata delegate record. The delegate is used to verify NFTs.
     *
     */
    collectionDelegateRecord?: PublicKey | Pda;
    /**
     * Token Metadata program.
     *
     */
    tokenMetadataProgram?: PublicKey | Pda;
    /** System program. */
    systemProgram?: PublicKey | Pda;
    /**
     * Instructions sysvar account.
     *
     */
    sysvarInstructions?: PublicKey | Pda;
    /**
     * Token Authorization Rules program.
     *
     */
    authorizationRulesProgram?: PublicKey | Pda;
    /**
     * Token Authorization rules account for the collection metadata (if any).
     *
     */
    authorizationRules?: PublicKey | Pda;
};
export declare type InitializeCandyMachineV2InstructionData = {
    discriminator: Array<number>;
    /** Number of assets available */
    itemsAvailable: bigint;
    /** Symbol for the asset */
    symbol: string;
    /** Secondary sales royalty basis points (0-10000) */
    sellerFeeBasisPoints: Amount<'%', 2>;
    /** Max supply of each individual asset (default 0) */
    maxEditionSupply: bigint;
    /** Indicates if the asset is mutable or not (default yes) */
    isMutable: boolean;
    /** List of creators */
    creators: Array<Creator>;
    /** Config line settings */
    configLineSettings: Option<ConfigLineSettings>;
    /** Hidden setttings */
    hiddenSettings: Option<HiddenSettings>;
    tokenStandard: TokenStandard;
};
export declare type InitializeCandyMachineV2InstructionDataArgs = {
    /** Number of assets available */
    itemsAvailable: number | bigint;
    /** Symbol for the asset */
    symbol?: string;
    /** Secondary sales royalty basis points (0-10000) */
    sellerFeeBasisPoints: Amount<'%', 2>;
    /** Max supply of each individual asset (default 0) */
    maxEditionSupply?: number | bigint;
    /** Indicates if the asset is mutable or not (default yes) */
    isMutable?: boolean;
    /** List of creators */
    creators: Array<CreatorArgs>;
    /** Config line settings */
    configLineSettings?: OptionOrNullable<ConfigLineSettingsArgs>;
    /** Hidden setttings */
    hiddenSettings?: OptionOrNullable<HiddenSettingsArgs>;
    tokenStandard: TokenStandardArgs;
};
/** @deprecated Use `getInitializeCandyMachineV2InstructionDataSerializer()` without any argument instead. */
export declare function getInitializeCandyMachineV2InstructionDataSerializer(_context: object): Serializer<InitializeCandyMachineV2InstructionDataArgs, InitializeCandyMachineV2InstructionData>;
export declare function getInitializeCandyMachineV2InstructionDataSerializer(): Serializer<InitializeCandyMachineV2InstructionDataArgs, InitializeCandyMachineV2InstructionData>;
export declare type InitializeCandyMachineV2InstructionArgs = InitializeCandyMachineV2InstructionDataArgs;
export declare function initializeCandyMachineV2(context: Pick<Context, 'programs' | 'eddsa' | 'identity' | 'payer'>, input: InitializeCandyMachineV2InstructionAccounts & InitializeCandyMachineV2InstructionArgs): TransactionBuilder;
