"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.mint = exports.getMintInstructionDataSerializer = void 0;
const mpl_token_metadata_1 = require("@metaplex-foundation/mpl-token-metadata");
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const hooked_1 = require("../../hooked");
const shared_1 = require("../shared");
function getMintInstructionDataSerializer(_context = {}) {
    return (0, serializers_1.mapSerializer)((0, serializers_1.struct)([
        ['discriminator', (0, serializers_1.array)((0, serializers_1.u8)(), { size: 8 })],
        ['mintArgs', (0, serializers_1.bytes)({ size: (0, serializers_1.u32)() })],
        ['group', (0, serializers_1.option)((0, serializers_1.string)())],
    ], { description: 'MintInstructionData' }), (value) => ({
        ...value,
        discriminator: [51, 57, 225, 47, 182, 146, 137, 166],
    }));
}
exports.getMintInstructionDataSerializer = getMintInstructionDataSerializer;
// Instruction.
function mint(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = context.programs.getPublicKey('mplCandyGuard', 'Guard1JwRhJkVH6XZhzoYxeBVQe872VH6QggF4BWmS9g');
    // Resolved inputs.
    const resolvedAccounts = {
        candyMachine: [input.candyMachine, true],
        nftMint: [input.nftMint, true],
        collectionMint: [input.collectionMint, false],
        collectionUpdateAuthority: [
            input.collectionUpdateAuthority,
            false,
        ],
    };
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'candyGuard', input.candyGuard
        ? [input.candyGuard, false]
        : [
            (0, hooked_1.findCandyGuardPda)(context, {
                base: (0, umi_1.publicKey)(input.candyMachine, false),
            }),
            false,
        ]);
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'candyMachineProgram', input.candyMachineProgram
        ? [input.candyMachineProgram, false]
        : [
            context.programs.getPublicKey('mplCandyMachine', 'CndyV3LdqHUfDLmE5naZjVN8rBZz4tqhdefbAnjHG3JR'),
            false,
        ]);
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'candyMachineAuthorityPda', input.candyMachineAuthorityPda
        ? [input.candyMachineAuthorityPda, true]
        : [
            (0, hooked_1.findCandyMachineAuthorityPda)(context, {
                candyMachine: (0, umi_1.publicKey)(input.candyMachine, false),
            }),
            true,
        ]);
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'payer', input.payer
        ? [input.payer, true]
        : [context.payer, true]);
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'nftMetadata', input.nftMetadata
        ? [input.nftMetadata, true]
        : [
            (0, mpl_token_metadata_1.findMetadataPda)(context, { mint: (0, umi_1.publicKey)(input.nftMint, false) }),
            true,
        ]);
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'nftMintAuthority', input.nftMintAuthority
        ? [input.nftMintAuthority, false]
        : [context.identity, false]);
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'nftMasterEdition', input.nftMasterEdition
        ? [input.nftMasterEdition, true]
        : [
            (0, mpl_token_metadata_1.findMasterEditionPda)(context, {
                mint: (0, umi_1.publicKey)(input.nftMint, false),
            }),
            true,
        ]);
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'collectionAuthorityRecord', input.collectionAuthorityRecord
        ? [input.collectionAuthorityRecord, false]
        : [
            (0, mpl_token_metadata_1.findCollectionAuthorityRecordPda)(context, {
                mint: (0, umi_1.publicKey)(input.collectionMint, false),
                collectionAuthority: (0, umi_1.publicKey)(resolvedAccounts.candyMachineAuthorityPda[0], false),
            }),
            false,
        ]);
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'collectionMetadata', input.collectionMetadata
        ? [input.collectionMetadata, true]
        : [
            (0, mpl_token_metadata_1.findMetadataPda)(context, {
                mint: (0, umi_1.publicKey)(input.collectionMint, false),
            }),
            true,
        ]);
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'collectionMasterEdition', input.collectionMasterEdition
        ? [input.collectionMasterEdition, false]
        : [
            (0, mpl_token_metadata_1.findMasterEditionPda)(context, {
                mint: (0, umi_1.publicKey)(input.collectionMint, false),
            }),
            false,
        ]);
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'tokenMetadataProgram', input.tokenMetadataProgram
        ? [input.tokenMetadataProgram, false]
        : [
            context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
            false,
        ]);
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'tokenProgram', input.tokenProgram
        ? [input.tokenProgram, false]
        : [
            context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA'),
            false,
        ]);
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'systemProgram', input.systemProgram
        ? [input.systemProgram, false]
        : [
            context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
            false,
        ]);
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'recentSlothashes', input.recentSlothashes
        ? [input.recentSlothashes, false]
        : [
            (0, umi_1.publicKey)('SysvarS1otHashes111111111111111111111111111'),
            false,
        ]);
    (0, shared_1.addObjectProperty)(resolvedAccounts, 'instructionSysvarAccount', input.instructionSysvarAccount
        ? [input.instructionSysvarAccount, false]
        : [
            (0, umi_1.publicKey)('Sysvar1nstructions1111111111111111111111111'),
            false,
        ]);
    const resolvedArgs = { ...input, ...resolvingArgs };
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.candyGuard, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.candyMachineProgram, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.candyMachine, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.candyMachineAuthorityPda, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.payer, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.nftMetadata, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.nftMint, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.nftMintAuthority, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.nftMasterEdition, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.collectionAuthorityRecord, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.collectionMint, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.collectionMetadata, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.collectionMasterEdition, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.collectionUpdateAuthority, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.tokenMetadataProgram, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.tokenProgram, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.systemProgram, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.recentSlothashes, false);
    (0, shared_1.addAccountMeta)(keys, signers, resolvedAccounts.instructionSysvarAccount, false);
    // Data.
    const data = getMintInstructionDataSerializer().serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.mint = mint;
//# sourceMappingURL=mint.js.map