/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
import { Context, Option, OptionOrNullable, Pda, PublicKey, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
import { Serializer } from '@metaplex-foundation/umi/serializers';
export declare type MintV2InstructionAccounts = {
    /** Candy Guard account. */
    candyGuard?: PublicKey | Pda;
    /**
     * Candy Machine program account.
     *
     */
    candyMachineProgram?: PublicKey | Pda;
    /** Candy machine account. */
    candyMachine: PublicKey | Pda;
    /**
     * Candy Machine authority account.
     *
     */
    candyMachineAuthorityPda?: PublicKey | Pda;
    /** Payer for the mint (SOL) fees. */
    payer?: Signer;
    /** Minter account for validation and non-SOL fees. */
    minter?: Signer;
    /**
     * Mint account of the NFT. The account will be initialized if necessary.
     *
     * Must be a signer if:
     * * the nft_mint account does not exist.
     *
     */
    nftMint: PublicKey | Pda | Signer;
    /**
     * Mint authority of the NFT before the authority gets transfer to the master edition account.
     *
     * If nft_mint account exists:
     * * it must match the mint authority of nft_mint.
     */
    nftMintAuthority?: Signer;
    /**
     * Metadata account of the NFT. This account must be uninitialized.
     *
     */
    nftMetadata?: PublicKey | Pda;
    /**
     * Master edition account of the NFT. The account will be initialized if necessary.
     *
     */
    nftMasterEdition?: PublicKey | Pda;
    /**
     * Destination token account (required for pNFT).
     *
     */
    token?: PublicKey | Pda;
    /**
     * Token record (required for pNFT).
     *
     */
    tokenRecord?: PublicKey | Pda;
    /**
     * Collection authority or metadata delegate record.
     *
     */
    collectionDelegateRecord?: PublicKey | Pda;
    /**
     * Mint account of the collection NFT.
     *
     */
    collectionMint: PublicKey | Pda;
    /**
     * Metadata account of the collection NFT.
     *
     */
    collectionMetadata?: PublicKey | Pda;
    /**
     * Master edition account of the collection NFT.
     *
     */
    collectionMasterEdition?: PublicKey | Pda;
    /**
     * Update authority of the collection NFT.
     *
     */
    collectionUpdateAuthority: PublicKey | Pda;
    /**
     * Token Metadata program.
     *
     */
    tokenMetadataProgram?: PublicKey | Pda;
    /** SPL Token program. */
    splTokenProgram?: PublicKey | Pda;
    /** SPL Associated Token program. */
    splAtaProgram?: PublicKey | Pda;
    /** System program. */
    systemProgram?: PublicKey | Pda;
    /**
     * Instructions sysvar account.
     *
     */
    sysvarInstructions?: PublicKey | Pda;
    /**
     * SlotHashes sysvar cluster data.
     *
     */
    recentSlothashes?: PublicKey | Pda;
    /**
     * Token Authorization Rules program.
     *
     */
    authorizationRulesProgram?: PublicKey | Pda;
    /**
     * Token Authorization rules account for the collection metadata (if any).
     *
     */
    authorizationRules?: PublicKey | Pda;
};
export declare type MintV2InstructionData = {
    discriminator: Array<number>;
    mintArgs: Uint8Array;
    group: Option<string>;
};
export declare type MintV2InstructionDataArgs = {
    mintArgs: Uint8Array;
    group: OptionOrNullable<string>;
};
/** @deprecated Use `getMintV2InstructionDataSerializer()` without any argument instead. */
export declare function getMintV2InstructionDataSerializer(_context: object): Serializer<MintV2InstructionDataArgs, MintV2InstructionData>;
export declare function getMintV2InstructionDataSerializer(): Serializer<MintV2InstructionDataArgs, MintV2InstructionData>;
export declare type MintV2InstructionArgs = MintV2InstructionDataArgs;
export declare function mintV2(context: Pick<Context, 'programs' | 'eddsa' | 'identity' | 'payer'>, input: MintV2InstructionAccounts & MintV2InstructionArgs): TransactionBuilder;
