import { TokenStandard } from '@metaplex-foundation/mpl-token-metadata';
import { Option, OptionOrNullable, TransactionBuilder } from '@metaplex-foundation/umi';
import { DefaultGuardSetMintArgs } from './defaultGuards';
import { MintV2InstructionAccounts, mintV2 as baseMintV2 } from './generated/instructions/mintV2';
import { GuardRepository, GuardSetMintArgs } from './guards';
export { MintV2InstructionAccounts };
export declare type MintV2InstructionData<MA extends GuardSetMintArgs> = {
    discriminator: Array<number>;
    mintArgs: MA;
    group: Option<string>;
};
export declare type MintV2InstructionDataArgs<MA extends GuardSetMintArgs> = {
    mintArgs?: Partial<MA>;
    group?: OptionOrNullable<string>;
    /** @defaultValue `TokenStandard.NonFungible`. */
    tokenStandard?: TokenStandard;
};
export declare function mintV2<MA extends GuardSetMintArgs = DefaultGuardSetMintArgs>(context: Parameters<typeof baseMintV2>[0] & {
    guards: GuardRepository;
}, input: MintV2InstructionAccounts & MintV2InstructionDataArgs<MA extends undefined ? DefaultGuardSetMintArgs : MA>): TransactionBuilder;
